{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}

unit wyvFav;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ToolWin, ShellAPI, FileCtrl, ActnList, MyFunc, BrowseDr;

type
  TFavForm = class(TForm)
    FvBar: TToolBar;
    Favb0: TToolButton;
    Favb1: TToolButton;
    Favb2: TToolButton;
    Favb3: TToolButton;
    Favb4: TToolButton;
    Favb5: TToolButton;
    Favb6: TToolButton;
    Favb7: TToolButton;
    FLV: TListView;
    ActionList1: TActionList;
    fvOpen: TAction;
    fvEdit: TAction;
    fvSelectAll: TAction;
    fvDelete: TAction;
    fvUp: TAction;
    fvDown: TAction;
    fvDir: TAction;
    Favb8: TToolButton;
    FavOpnDlg: TOpenDialog;
    FavStatusBar: TStatusBar;
    ToolButton1: TToolButton;
    FLVBrief: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure fvDownExecute(Sender: TObject);
    procedure fvUpExecute(Sender: TObject);
    procedure fvDeleteExecute(Sender: TObject);
    procedure fvSelectAllExecute(Sender: TObject);
    procedure fvEditExecute(Sender: TObject);
    procedure fvOpenExecute(Sender: TObject);
    procedure fvDirExecute(Sender: TObject);
    procedure fvSelectAllUpdate(Sender: TObject);
    procedure fvUpUpdate(Sender: TObject);
    procedure fvDownUpdate(Sender: TObject);
    procedure fvDeleteUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FLVEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure FLVDblClick(Sender: TObject);
    procedure FLVDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FLVDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FLVColumnClick(Sender: TObject; Column: TListColumn);
    procedure FLVCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Favb7Click(Sender: TObject);
    procedure FLVSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FavStatusBarDblClick(Sender: TObject);
  private
    { Private 錾 }
    FLVPop: TPopupMenu;
    DragIdx,lstSort2: integer;
    FFLVPreWndProc: TWndMethod;
    procedure ReloadMainPop;
    procedure PopMenuInitialize;
    procedure FLVWndProc(var Msg: TMessage);
  public
    { Public 錾 }
    procedure CreateParams(var Params: TCreateParams);override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  end;

var
  FavForm: TFavForm;

implementation

uses wyvMain, wyvSub, wyvResStr, wyvPref;

{$R *.DFM}

{ TFavForm }

procedure TFavForm.FLVWndProc(var Msg: TMessage);
begin
    FFLVPreWndProc(Msg);
    if Msg.Msg = CM_WANTSPECIALKEY then
      if (TWMKey(Msg).CharCode = VK_DELETE) and (FLV.IsEditing) then
        Msg.Result  :=  1;
end;

procedure TFavForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle    :=  Params.EXStyle or WS_EX_ACCEPTFILES;
    Params.WndParent  :=  Main.Panel1.Handle;
end;

procedure TFavForm.FormCreate(Sender: TObject);
var Cnt: integer;
begin
    if not Main.staytop.Down then
      Self.FormStyle := fsNormal;
    with Self do begin
      if Main.FvLeft <> 0 then
        Left := Main.FvLeft
      else
        Left := (Screen.Width - Width)  div 2;
      if Main.FvTop <> 0 then
        Top := Main.FvTop
      else
        Top  := (Screen.Height - Top)  div 2;
      Width := Main.FvWidth; Height := Main.FvHeight;
    end;
    FLV.Column[0].Width := Main.FLVClmn0;
    FLV.Column[1].Width := Main.FLVClmn1;
    FFLVPreWndProc  := FLV.WindowProc;
    FLV.WindowProc  := FLVWndProc;

    FLVPop          := TPopupMenu.Create(Self);
    FLVPop.Images   := Main.ImageList1;
    PopMenuInitialize;
    FLV.PopupMenu   := FLVPop;
    FLV.StateImages := Main.SysImg;
    //FLV.StateImages := Main.ImageList2;
    Favb7.Down      := Main.IsFavoriteAdd;
    Favb8.Down      := Main.IsFavoritePlay;
    lstSort2        := 0;
    with Main do begin
      if FvrtPop.Items.Count > 0 then
        for Cnt := 0 to FvrtPop.Items.Count - 1 do
          AddToFavoriteList(FvrtPop.Items[Cnt].Caption,
                            FvrtPop.Items[Cnt].Hint,
                            FLV, -1);
    end;
    if not Main.plvHot.Checked then
      FLV.HotTrackStyles := [];

    FLVPop.OnPopup := Main.chkPopUpdate;

    if Main.FLVStyle then
      FLV.ViewStyle := vsReport
    else
      FLV.ViewStyle := vsList;
    FLVBrief.Down := (FLV.ViewStyle = vsList);
end;

procedure TFavForm.FormDestroy(Sender: TObject);
begin
    FLVPop.Free;
end;

procedure TFavForm.ReloadMainPop;
var Cnt: integer;
begin
    Main.FvrtPop.Items.Clear;
    Main.FavoriteMenu.Clear;
    for Cnt := 0 to FLV.Items.Count - 1 do
      Main.AddToFavoriteMenu(FLV.Items[Cnt].Caption,
    FLV.Items[Cnt].SubItems[0],
    FLV.Items[Cnt].StateIndex);
end;

procedure TFavForm.fvDownExecute(Sender: TObject);
begin
    with FLV do begin
      if (SelCount = 0) or (Items[Items.Count - 1].Selected) then Exit;
      Main.ListItemMove(FLV,1);
    end;
    ReloadMainPop;
end;

procedure TFavForm.fvUpExecute(Sender: TObject);
begin
    with FLV do begin
      if (SelCount = 0) or (Items[0].Selected) then Exit;
      Main.ListItemMove(FLV, -1);
    end;
    ReloadMainPop;
end;

procedure TFavForm.fvDeleteExecute(Sender: TObject);
var delBgn: integer;
begin
     with FLV do begin
       if (IsEditing) or (SelCount = 0) then Exit;
       delBgn := Selected.Index;
       while delBgn < Items.Count do
         if Items[delBgn].Selected then
           Items.Delete(delBgn)
         else
           Inc(delBgn);
     end;
     ReloadMainPop;
end;

procedure TFavForm.fvSelectAllExecute(Sender: TObject);
var Cnt: integer;
begin
     with FLV do begin
       if (IsEditing) or (Items.Count = 0) then Exit;
       Items.BeginUpdate;
       for Cnt := 0 to Items.Count - 1 do
         Items[CNt].Selected := True;
       Items.EndUpdate;
     end;
end;

procedure TFavForm.fvEditExecute(Sender: TObject);
begin
     with FLV do
       if Selected <> nil then Selected.EditCaption;
end;

procedure TFavForm.fvOpenExecute(Sender: TObject);
var Cnt: integer;
begin
    if FLV.IsEditing then Exit;
    if (Main.staytop.Down) or
       ((Main.GNOpt[_GN_MINITOP]) and (Sub.Visible)) then
      Main.NoTopMost(Main.Handle);
    //Main.OpenDialog1.Title := 'CɓɃt@Cǉ';
    if FavOpnDlg.InitialDir = '' then
      FavOpnDlg.InitialDir := Main.DefaultDir;
    if FavOpnDlg.Execute then begin
      with FavOpnDlg do
        for Cnt := 0 to Files.Count - 1 do
          Main.AddToFavoriteList(Files[Cnt], Files[Cnt],
            FLV, -1);
      ReloadMainPop;
      FavOpnDlg.InitialDir := ExtractFileDir(FavOpnDlg.Files[0]);
    end;
    if (Main.staytop.Down) or
    ((Main.GNOpt[_GN_MINITOP]) and (Sub.Visible)) then
      Main.TopMost(Main.Handle);
end;

procedure TFavForm.fvDirExecute(Sender: TObject);
var Dir:string;
begin
    with TdfsBrowseDirectoryDlg.Create(Self) do begin
      try
        ShowSelectionInStatus := true;
        Caption := 'tH_̑I';
        Title   := 'wtH_CɓACeɒǉ܂';
        Selection := Main.DefaultDir;
        if Execute then begin
          Dir := Selection;
          Main.DefaultDir := Dir;
          Main.AddToFavoriteList(Dir, Dir, FLV, -1);
          ReloadMainPop;
        end;
      finally
        Free;
      end;
    end;
end;


procedure TFavForm.PopMenuInitialize;
var Cnt: integer;
    addMenu: TMenuItem;
begin
    for Cnt := 0 to 3 do begin
      addMenu        := TMenuItem.Create(Self);
      addMenu.Action := ActionList1.Actions[Cnt];
      FLVPop.Items.Add(addMenu);
    end;
    addMenu         := TMenuItem.Create(Self);
    addMenu.Caption := '-';
    FLVPop.Items.Add(addMenu);
    for Cnt := 4 to ActionList1.ActionCount - 1 do begin
      addMenu        := TMenuItem.Create(Self);
      addMenu.Action := ActionList1.Actions[Cnt];
      FLVPop.Items.Add(addMenu);
    end;
    if Main.PopupMenu2.Images = nil then begin
      FLVPop.Images := nil;
      with FLVPop.Items[3] do
        Caption := Caption + #9 + 'Del' + #0;
    end;
end;

procedure TFavForm.fvSelectAllUpdate(Sender: TObject);
begin
    with FLV do
      fvSelectAll.Enabled := (SelCount < Items.Count);
end;

procedure TFavForm.fvUpUpdate(Sender: TObject);
begin
    with FLV do
      fvup.Enabled := (SelCount > 0) and (not Items[0].Selected);
end;

procedure TFavForm.fvDownUpdate(Sender: TObject);
begin
    with FLV do
      fvDown.Enabled := (SelCount > 0) and (not Items[Items.Count - 1].Selected);
end;

procedure TFavForm.fvDeleteUpdate(Sender: TObject);
begin
    with FLV do
      (Sender as TAction).Enabled := (SelCount > 0);
end;

procedure TFavForm.WMDropFiles(var Msg: TWMDropFiles);
var DFile: array[0..MAX_PATH] of Char; ifl, Cnt: Integer;
    FlName: string;
begin
    Cnt := DragQueryFile(
    Msg.Drop, DWord(-1), DFile, SizeOf(DFile));
    for ifl := 0 to Cnt - 1 do begin
      DragQueryFile(Msg.Drop, DWord(ifl), DFile, SizeOf(DFile));
      FlName := ShortToLong(String(DFile));
      Main.AddToFavoriteList(FlName, FlName, FLV, -1);
    end;
    DragFinish(Msg.Drop);
    ReloadMainPop;
end;

procedure TFavForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Main.FvLeft   := Self.Left;
    Main.FvTop    := Self.Top;
    Main.FvHeight := Self.Height;
    Main.FvWidth  := Self.Width;
    Main.FLVClmn0 := FLV.Column[0].Width;
    Main.FLVClmn1 := FLV.Column[1].Width;
    Main.FvrtButton.Down := False;
    Action := caFree;
end;

procedure TFavForm.FLVEdited(Sender: TObject; Item: TListItem;
  var S: String);
begin
    Item.Caption := S;
    ReloadMainPop;
end;

procedure TFavForm.FLVDblClick(Sender: TObject);
begin
    if FLV.SelCount = 1 then
      Main.FvrtClick(FLV.Selected)
end;

procedure TFavForm.FLVDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var Target: TListItem;
begin
    Accept := False;
    if not (Sender is TListView) or
       ((Sender as TListView) <> FLV) then exit;
    Target := FLV.GetItemAt(X,Y);
    if Target <> nil then begin
      //if FLV.Selected <> nil then begin
        DragIdx := Target.Index;
        Accept  := True;
      //end;
    end
    else
    if (Source as TListView) = Main.ListView1 then
      Accept  := True;
end;

procedure TFavForm.FLVDragDrop(Sender, Source: TObject; X, Y: Integer);
var DoItem: TListItem;
    Cnt, Idx: integer;
    ShiftDown: boolean;
    TitleStr: string;
begin
  if Source is TListView then begin
    DoItem  := FLV.GetItemAt(X,Y);
    if ((Source as TListView) = FLV) and
       (FLV.Items.Count > 0) and
       (FLV.SelCount > 0) and
       (FLV.Selected <> nil) and
       (DoItem <> nil) and
       (FLV.ItemFocused <> nil) and
       (DragIdx > -1) and
       (DoItem.ListView = FLV) then begin
      Main.ListItemMove(FLV, DoItem.Index - FLV.ItemFocused.Index);
      ReloadMainPop;
    end
    else
    if ((Source as TListView) = Main.ListView1) and
       (Main.ListView1.SelCount > 0) then begin
      with Main.ListView1 do begin
        ShiftDown := ((GetAsyncKeyState(VK_MENU) and $8000) = 0);
        if FLV.GetItemAt(X,Y) <> nil then begin
          Idx := FLV.GetItemAt(X,Y).Index;
          for Cnt := Items.Count - 1 downto Selected.Index do begin
            if Items[Cnt].Selected then begin
              if ShiftDown then
                TitleStr := Items[Cnt].SubItems[0]
              else
                TitleStr := Items[Cnt].SubItems[7];
              Main.AddToFavoriteList(TitleStr, Items[Cnt].SubItems[7],
                FLV, Idx);
            end;
          end;
        end
        else begin
          for Cnt := Selected.Index to Items.Count - 1 do begin
            if Items[Cnt].Selected then begin
              if ShiftDown then
                TitleStr := Items[Cnt].SubItems[0]
              else
                TitleStr := Items[Cnt].SubItems[7];
              Main.AddToFavoriteList(TitleStr, Items[Cnt].SubItems[7],
                FLV, -1);
            end;
          end;
        end;
        ReloadMainPop;
      end;
    end;
  end;
end;

procedure TFavForm.FLVColumnClick(Sender: TObject; Column: TListColumn);
begin
    if Abs(lstSort2) = Column.Index + 1 then
      lstSort2 := -lstSort2
    else
      lstSort2 := Column.Index + 1;
    FLV.SortType := stNone;
    FLV.SortType := stData;
    ReloadMainPop;
end;

procedure TFavForm.FLVCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
begin
    case lstSort2 of
      0:      Compare := 0;
      1, -1:  Compare := AnsiCompareStr(Item1.Caption,Item2.Caption);
      else    Compare := AnsiCompareStr(Item1.SubItems[Abs(lstSort2) - 2],
                                        Item2.SubItems[Abs(lstSort2) - 2]);
    end;
    if lstSort2 < 0 then
      Compare := -Compare;
end;

procedure TFavForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    case Key of
      VK_ESCAPE: //if chkEsc then
                 Close;
      VK_DELETE: fvDeleteExecute(nil);
      VK_RETURN: FLVDblClick(nil);
    end;
end;

procedure TFavForm.Favb7Click(Sender: TObject);
begin
    case (Sender as TToolButton).Index of
      7: Main.IsFavoriteAdd  := (Sender as TToolButton).Down;
      8: Main.IsFavoritePlay := (Sender as TToolButton).Down;
    end;
end;

procedure TFavForm.FLVSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if FLV.SelCount > 0 then
    FavStatusBar.SimpleText := FLV.Selected.SubItems[0]
  else
    FavStatusBar.SimpleText := '';
end;

procedure TFavForm.FavStatusBarDblClick(Sender: TObject);
begin
  FLV.StateImages := Main.SysImg;
  Main.FLVStyle := not Main.FLVStyle;
  if Main.FLVStyle then
    FLV.ViewStyle := vsReport
  else
    FLV.ViewStyle := vsList;
  FLVBrief.Down := (FLV.ViewStyle = vsList);
end;

end.
