{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}
unit wyvSub;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, StdCtrls, IniFiles, ShellAPI, mp3plyr, ScrollLabel;

type
  TSub = class(TForm)
    ToolBar1: TToolBar;
    MiniPrevButton: TToolButton;
    MiniStopButton: TToolButton;
    MiniPlayButton: TToolButton;
    MiniPauseButton: TToolButton;
    MiniNextButton: TToolButton;
    MiniForButton: TToolButton;
    MiniMiniButton: TToolButton;
    Label1: TLabel;
    MiniTaskTrayButton: TToolButton;
    MiniRevButton: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1DblClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure ToolButton1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MiniForButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
  private
    subsetp,submovp: TPoint;
    procedure ScrollLabelInitilize;
    { Private 錾 }
  public
    { Public 錾 }
    ScrollLabel1: TScrollLabel;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure WMMoving(var Msg: TMessage); message WM_MOVING;
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

var
  Sub: TSub;

const
  BrkTime = 250;

implementation

uses wyvMain, wyvPref;

{$R *.DFM}


procedure TSub.ScrollLabelInitilize;
begin
  ScrollLabel1 := TScrollLabel.Create(Self);
  with ScrollLabel1 do begin
    Parent := Sub;
    Left   := 0;
    Top    := 0;
    AutoSize := false;
    Align  := alClient;
    Layout := tlCenter;
    ShowAccelChar := false;
    OnMouseDown := Label1MouseDown;
    OnMouseUp   := Label1MouseUp;
    OnDblClick  := Label1DblClick;
  end;
end;

procedure TSub.FormCreate(Sender: TObject);
var wyvini: TMemIniFile;
    NextRnd: integer;
    btyp: Byte;
begin
     ScrollLabelInitilize;
     wyvini := TMemIniFile.Create(ExtractFilePath(Application.ExeName)+'wyvset.ini');
     try
     with wyvini,Sub do begin
     Top    := ReadInteger('Window','MiniTop'    ,Top );
     Left   := ReadInteger('Window','MiniLeft'   ,Left);
     Width  := ReadInteger('Window','MiniWidth'  ,Width);
        with Label1 do begin
        Font.Charset := ReadInteger('Window','MListCharset', Font.Charset);
        Font.Name    := ReadString('Window',  'MListFontName', Font.Name);
        Font.Size    := ReadInteger('Window', 'MListFontSize', Font.Size);
        Font.Color   := StringToColor(ReadString('Window','MListFontColor',ColorToString(Font.Color)));
        btyp         := ReadInteger('Window', 'MListFontStyle', byte(Font.Style));
        Font.Style   := TFontStyles(btyp);
        end;
        ScrollLabel1.Font.Assign(Label1.Font);

        with ScrollLabel1 do begin
        Interval := ReadInteger('Window', 'LabelInterval', Interval);
        Step     := ReadInteger('Window', 'LabelStep',     Step);
        end;
     end;
     finally
       wyvini.Free;
     end;

     SetWindowLong(Handle,GWL_STYLE,GetWindowLong(Handle, GWL_STYLE)
                   and not WS_CAPTION);
     ClientHeight := Height;
     Refresh;

     Main.TBManager.Add('Mini', Sub.ToolBar1);
     Main.TBManager.Init(2);
     Main.TBManager.Load(2);

     if (IsMiniView or Main.GNOpt[_GN_STRTMINI]) and
        (not Main.GNOpt[_GN_STRTTRAY]) then begin
       Application.Minimize;
       Sub.Visible := True;
       ShowWindow(Application.Handle,SW_HIDE);
       if (Main.GNOpt[_GN_MINITOP]) or (Main.staytop.Down) then
         Main.TopMost(Main.Handle);
       SetForegroundWindow(Sub.Handle);
       HotStat := hsMini;
     end;
     with Main do begin
       if (ListView1.Items.Count > 0) and
          ((bgnTrk = plc) or GNOpt[_GN_AUTOPLAY]) then begin
         if IsRandom.Down then begin
           NextRnd := GetNextRandomNumBer;
           playtrack(NextRnd);
         end
         else
           playtrack(plc);
       end;
     end;

     Main.MP3Player1ChangeStatus(nil);
     Main.RefreshSubButton;
     if Main.MP3Player1.IsOpen then Main.statusCall;
end;

procedure TSub.FormShow(Sender: TObject);
begin
     GetCursorPos(setp);
     movep := setp;
     if (PaintIni) and ((Main.GNOpt[_GN_MINITOP]) or (Main.staytop.Down)) then begin
       Main.TopMost(Main.Handle);
     end;
     if PaintIni then begin
       ToolBar1.AutoSize := Main.IsMiniTB.Checked;
       if not Main.IsMiniTB.Checked then begin
         ToolBar1.Width := 1;
       end;
     end;
end;

procedure TSub.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.WndParent  :=  Main.Handle;
    Params.ExStyle    :=  Params.EXStyle or WS_EX_ACCEPTFILES;
end;
procedure TSub.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if ssLeft in Shift then begin
      ReleaseCapture;
      SendMessage (Handle, WM_SYSCOMMAND, $F012, 0);
      Label1.Perform(WM_LBUTTONUP,0,MakeLParam(X,Y));
    end;
end;

procedure TSub.Label1DblClick(Sender: TObject);
begin
     case Main.MiniDbClick of
      0: if Main.actNext.Enabled then
           Main.actNextExecute(nil);
      1: MiniMiniButton.Click;
      2: MiniTaskTrayButton.Click;
     end;
end;

procedure TSub.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Shift = [ssCtrl] then begin
       case Key of
        VK_PRIOR: begin
                    Key := Word(#0);
                    with Main.ScrollBar1 do begin
                      if Position < 98 then begin
                        Position := Position + 2;
                        //OnChange(Sender);
                      end;
                      APplication.ProcessMessages;
                    end;
                  end;
        VK_NEXT : begin
                    Key := Word(#0);
                    with Main.ScrollBar1 do begin
                      if Position > 2 then begin
                        Position := Position - 2;
                        //OnChange(Sender);
                      end;
                      Application.ProcessMessages;
                    end;
                  end;
        VK_F12  : begin
                    Key := Word(#0);
                    MiniMiniButton.Click;
                  end;
        else
          Key := Word(#0);
       end;
     end
     else
     if (Key = VK_ESCAPE) and (Main.GNOpt[_GN_ESCQUIT]) then begin
       Key := Word(#0); Main.actQuitExecute(nil);
     end;
end;

procedure TSub.WMMoving(var Msg: TMessage);
var  Lmargin,Tmargin,Rmargin,Bmargin: integer;
begin
     if not Main.SnapMini.Checked then Exit; 
     Lmargin := 0; Tmargin := 0; Rmargin := 0; Bmargin := 0;
     with Main.TBRect do begin
       if (Left <= 3) and (Top <= 3) and (Abs(Right - Screen.Width) <= 3) then
         Tmargin := Bottom - Top + 2
       else
       if (Top <= 3)  and (Abs(Right - Screen.Width) <= 3)
          and (Abs(Bottom - Screen.Height) <= 3) then
         Rmargin := Right - Left - 2
       else
       if (Left <= 3) and (Abs(Right - Screen.Width) <= 3)
          and (Abs(Bottom - Screen.Height) <= 3) then
         Bmargin := Bottom - Top - 2
       else
       if (Left <= 3) and (Abs(Bottom - Screen.Height) <= 3)
        and (Top <= 3) then
         Lmargin := Right - Left + 2;
     end;
     GetCursorPos(submovp);
     with PRect(Msg.LParam)^ do begin
       if (subsetp.x > submovp.x) and
          (Left < Main.snpLgth + Lmargin) then begin
         Left := Lmargin; Right := Sub.Width + Lmargin;
       end;
       if (subsetp.y > submovp.y) and
          (Top < Main.snpLgth + Tmargin) then begin
         Top := Tmargin; Bottom := Sub.Height + Tmargin;
       end;
       if (subsetp.x < submovp.x) and
          (Right > Screen.Width - Main.snpLgth - Rmargin) then begin
         Right := Screen.Width - Rmargin;
         Left := Screen.Width - Sub.Width - Rmargin;
       end;
       if (subsetp.y < submovp.y) and
          (Bottom > Screen.Height - Main.snpLgth - Bmargin) then begin
         Bottom := Screen.Height - Bmargin;
         Top := Screen.Height - Sub.Height - Bmargin;
       end;
     end;
     GetCursorPos(subsetp);
end;

procedure TSub.WMDropFiles(var Msg: TWMDropFiles);
var FileCount, FileIndex, FileNameLength: Cardinal;
    FileName: string;
    DList: TStringList;
begin
     FileCount := 0;
     try
       FileCount := DragQueryFile(Msg.Drop, $ffffffff, nil, 0);
       if FileCount > 0 then begin
         DList := TStringList.Create;
         try
           for FileIndex := 0 to FileCount - 1 do begin
             FileNameLength := DragQueryFile(Msg.Drop, FileIndex, nil, 0);
             SetLength(FileName, FileNameLength);
             DragQueryFile(Msg.Drop, FileIndex, PChar(FileName), FileNameLength + 1);
             DList.Add(FileName);
           end;
           Main.GetDropedFiles(DList);
         finally
           DList.Free;
         end;
       end;
     finally
       DragFinish(Msg.Drop);
     end;
     with Main do begin
       RefreshTrackNumber;
       statuscall;
       RefreshTrackNumber;
       SelCountView;
       //ModifySelectPlay;
     end;
end;

procedure TSub.WMSysCommand(var Msg: TWMSysCommand);
begin
    if Msg.CmdType = SC_CLOSE then Main.Close
    else inherited;
end;

procedure TSub.ToolButton1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ctime: UINT;
begin
    if (Main.MP3Player1.IsOpen) and (Shift = [ssLeft]) then begin
      MiniRevButton.Down := true;
      MiniRevButton.Refresh;
      Main.actReverseExecute(nil);
      ctime := GetTickCount + BrkTime;
      while GetTickCount<ctime do Application.ProcessMessages;
      while (GetAsyncKeyState(VK_LBUTTON) and $8000)<>0 do begin
        Main.actReverseExecute(nil);
        Application.ProcessMessages;
      end;
      mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
      mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
      MiniRevButton.Down := false;
      MiniRevButton.Refresh;
    end;
end;

procedure TSub.MiniForButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ctime: UINT;
begin
    if (Main.MP3Player1.IsOpen) and (Shift = [ssLeft]) then begin
      MiniForButton.Down := true;
      MiniForButton.Refresh;
      Main.actForwardExecute(nil);
      ctime := GetTickCount + BrkTime;
      while GetTickCount < ctime do Application.ProcessMessages;
      while (GetAsyncKeyState(VK_LBUTTON) and $8000) <> 0 do begin
        Main.actForwardExecute(nil);
        Application.ProcessMessages;
      end;
      mouse_event(MOUSEEVENTF_LEFTDOWN,0,0,0,0);
      mouse_event(MOUSEEVENTF_LEFTUP,0,0,0,0);
      MiniForButton.Down := false;
      MiniForButton.Refresh;
    end;
end;

procedure TSub.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ps: TPoint;
begin
    if Button = mbRight then begin
      if (GetAsyncKeyState(VK_SHIFT) and $8000) <> 0 then begin
        GetCursorPos(ps);
        Main.PopupMenu2.Popup(ps.x,ps.y);
      end
      else
      if (GetAsyncKeyState(VK_CONTROL) and $8000) <> 0 then
        Main.PopupVPCtrl
      else begin
        GetCursorPos(ps);
        if (Main.GNOpt[_GN_MINIRIGHT]) and (Main.FvrtPop.Items.Count > 0) then
          Main.FvrtPop.Popup(ps.x, ps.y)
        else
        begin
          chkPop := True;
          Main.PopupMenu4.Popup(ps.x,ps.y);
          chkPop := False;
        end;
      end;
    end
    else
    if Button=mbMiddle then Main.PopupVPCtrl;
end;

procedure TSub.FormResize(Sender: TObject);
begin
    ClientHeight := 23;
end;


end.
