unit ImageListEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ShellAPI;

type
  TImageListEx = class(TImageList)
  private
    { Private 錾 }
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    function GetFileImageIndex(FileName: string): integer;
  published
    { Published 錾 }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TImageListEx]);
end;

{ TImageListEx }

function TImageListEx.GetFileImageIndex(FileName: string): integer;
var FileInfo: TSHFileInfo;
    MIcon: TIcon;
begin
  SHGetFileInfo(PChar(FileName), File_Attribute_Normal,
  		FileInfo, SizeOf(FileInfo),
  		SHGFI_ATTRIBUTES or SHGFI_ICON or SHGFI_SMALLICON);
  MIcon        := TIcon.Create;
  MIcon.Handle := FileInfo.hIcon;
  Self.AddIcon(MIcon);
  MIcon.Free;
  Result := Self.Count - 1;
end;

end.
