
{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, ActnList, Clipbrd, ShellAPI, FileCtrl,MyFunc,
  MP3Plyr, BrowseDr, ToolWin;

type
  TDMain = class(TForm)
    DList: TListView;
    StatusBar1: TStatusBar;
    ActionList1: TActionList;
    OpenSource: TAction;
    DeleteItem: TAction;
    UpItem: TAction;
    DownItem: TAction;
    DecodeItem: TAction;
    SelectItem: TAction;
    DeselectItem: TAction;
    SelectAllItem: TAction;
    PasteItem: TAction;
    OpenSourceDir: TAction;
    AbortItem: TAction;
    EditItem: TAction;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Panel1: TPanel;
    DefCheck: TCheckBox;
    FolderBrowse: TButton;
    FolderBox: TComboBox;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    EditDecodeItemMenu: TPopupMenu;
    EditDestination1: TMenuItem;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ChangeFolder: TAction;
    ChangeFolder1: TMenuItem;
    N1: TMenuItem;
    ClearStatus: TAction;
    ClearStatus1: TMenuItem;
    ToolButton13: TToolButton;
    procedure FolderBrowseClick(Sender: TObject);
    procedure OpenSourceExecute(Sender: TObject);
    procedure DeleteItemUpdate(Sender: TObject);
    procedure UpItemUpdate(Sender: TObject);
    procedure DownItemUpdate(Sender: TObject);
    procedure MakeIniFile1Click(Sender: TObject);
    procedure SelectAllItemUpdate(Sender: TObject);
    procedure SelectItemExecute(Sender: TObject);
    procedure SelectAllItemExecute(Sender: TObject);
    procedure PasteItemExecute(Sender: TObject);
    procedure DeleteItemExecute(Sender: TObject);
    procedure UpItemExecute(Sender: TObject);
    procedure DListDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DListDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure OpenSourceDirExecute(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AbortItemExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DecodeItemExecute(Sender: TObject);
    procedure DMP3EndPlay(Sender: TObject;
      Reason: TMP3EndPlayReason);
    procedure PasteItemUpdate(Sender: TObject);
    procedure EditItemExecute(Sender: TObject);
    procedure DMP3ChangePosition(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    //procedure CopyItemExecute(Sender: TObject);
    procedure DListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ChangeFolderExecute(Sender: TObject);
    procedure ClearStatusExecute(Sender: TObject);
  private
    { Private 錾 }
    dgIdx: integer;
    EList: TList;
    DecEnd: Boolean;
    DecPop: TPopupMenu;
    DMP3: TMP3Player;
    OldFileName: string;
    //FolderBox: TComboBox;
    Prg: TProgressBar;
    procedure FileAddToList(SrcFile: string);
    procedure DirAddToList(SrcDir: string);
    procedure ListItemMove(MoveCount: integer);
    procedure DecodeUnderEntry;
  public
    { Public 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  end;

var
  DMain: TDMain;

implementation

uses wyvMain, wyvResStr;

{$R *.DFM}

{ TDMain }

procedure TDMain.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle   :=  Params.EXStyle or WS_EX_ACCEPTFILES;
    Params.WndParent :=  Main.Handle;
end;

procedure TDMain.FileAddToList(SrcFile: string);
var SrcExt,DesPath: string;
    FL: TStringList;
    Cnt: integer;
begin
    SrcExt := LowerCase(ExtractFileExt(SrcFile));
    if (not DefCheck.Checked) or (FolderBox.Text = '') then
      DesPath := ExtractFilePath(SrcFile)
    else
      DesPath := FolderBox.Text;
    if (SrcExt = '.mp3') and (FileExists(SrcFile)) then
      with DList.Items.Add do begin
        Caption := ExtractFileName(SrcFile);
        SubItems.Add('');
        SubItems.Add(DesPath + ChangeFileExt(ExtractFileName(SrcFile), '.wav'));
        SubItems.Add(SrcFile);
      end
    else
    if SrcExt = '.m3u' then begin
      FL := TStringList.Create;
      try
        Fl.LoadFromFile(SrcFile);
        if FL.Count > 0 then
          for Cnt := 0 to FL.Count - 1 do
            FileAddToList(FL.Strings[Cnt]);
      finally
        FL.Free;
      end;
    end
    else
    if DirectoryExists(SrcFile) then
      DirAddToList(SrcFile);
end;

procedure TDMain.WMDropFiles(var Msg: TWMDropFiles);
var DFile: array[0..MAX_PATH] of Char;
    ifl, Cnt: Integer;
begin
    Cnt := DragQueryFile(Msg.Drop, DWord(-1), DFile, SizeOf(DFile));
    for ifl  :=  0 to Cnt - 1 do begin
      DragQueryFile(Msg.Drop, DWord(ifl), DFile, SizeOf(DFile));
      FileAddToList(ShortToLong(String(DFile)));
    end;
    DragFinish(Msg.Drop);
end;

procedure TDMain.FolderBrowseClick(Sender: TObject);
var Dir: string; Cnt: integer;
begin
    with TdfsBrowseDirectoryDlg.Create(Self) do begin
      try
        ShowSelectionInStatus := true;
        Caption := 'tH_̑I';
        Title   := 'ftHg̏o̓tH_w';
        Selection := Main.DefaultDir;
        if Execute then begin
          Dir := Selection;
          if Copy(Dir, Length(Dir), 1) <> '\' then
            Dir := Dir + '\';
          Main.DefaultDir := Dir;
          with FolderBox do begin
            Items.Add(Dir);
            //Main.DecDesList.Add(Dir);
            Cnt := Length(Main.DecDesArr);
            SetLength(Main.DecDesArr, Cnt + 1);
            Main.DecDesArr[Cnt] := Dir;
            ItemIndex := Items.Count - 1;
          end;
        end;
      finally
        Free;
      end;
    end;
    //if Main.staytop.Down then Main.TopMost(Main.Handle);
end;

procedure TDMain.OpenSourceExecute(Sender: TObject);
var Cnt: integer;
begin
    {if Main.staytop.Down then Main.NoTopMost(Main.Handle);
    if DecOpnDlg.InitialDir = '' then
      DecOpnDlg.InitialDir := Main.DefaultDir;
    if DecOpnDlg.Execute then begin
      for Cnt := 0 to DecOpnDlg.Files.Count - 1 do
        FileAddToList(DecOpnDlg.Files[Cnt]);
      DecOpnDlg.InitialDir := ExtractFileDir(DecOpnDlg.Files[0]);
    end;
    if Main.staytop.Down then Main.TopMost(Main.Handle);}
    with TOpenDialog.Create(Self) do begin
      try
        Filter := 'mp3file(*.mp3),playlistfile(*.m3u)|*.mp3;*.m3u';
        InitialDir := Main.DefaultDir;
        Options := Options + [ofAllowMultiSelect];
        if Execute then begin
           for Cnt := 0 to Files.Count - 1 do begin
             FileAddToList(Files[Cnt]);
           end;
        end;
      finally
        Free;
      end;
    end;
end;

procedure TDMain.DeleteItemUpdate(Sender: TObject);
begin
    (Sender as TAction).Enabled := (not DMP3.IsOpen) and (DList.SelCount > 0);
end;

procedure TDMain.UpItemUpdate(Sender: TObject);
begin
    with DList do
    UpItem.Enabled := (SelCount > 0) and (not Items[0].Selected);
end;

procedure TDMain.DownItemUpdate(Sender: TObject);
begin
    with DList do
    DownItem.Enabled := (SelCount > 0) and (not Items[Items.Count - 1].Selected);
end;

procedure TDMain.MakeIniFile1Click(Sender: TObject);
begin
    (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked; 
end;

procedure TDMain.SelectAllItemUpdate(Sender: TObject);
begin
    with DList do
    SelectAllItem.Enabled := (Items.Count > 0) and (SelCount < Items.Count);
end;

procedure TDMain.SelectItemExecute(Sender: TObject);
var Cnt: integer;
    EntryCheck: Boolean;
begin
    with DList do begin
    if DList.SelCount = 0 then Exit;
    //EntryCheck := ((Sender as TAction).Name = 'SelectItem');
    EntryCheck := ((Sender as TAction) = SelectItem);
    for Cnt := Selected.Index to Items.Count - 1 do
      if Items[Cnt].Selected then
        Items[Cnt].Checked := EntryCheck;
    end;
end;

procedure TDMain.SelectAllItemExecute(Sender: TObject);
var Cnt:integer;
begin
    with DList do begin
      if Items.Count = 0 then Exit;
      for Cnt := 0 to Items.Count - 1 do
        Items[Cnt].Selected := True;
    end;
end;

procedure TDMain.PasteItemExecute(Sender: TObject);
var CFList: TStringList;
    Cnt: integer;
begin
    if Clipboard.AsText <> '' then begin
      CFList := TStringList.Create;
      try
        CFList.Text := Clipboard.AsText;
        if CFList.Count > 0 then
          for Cnt := 0 to CFList.Count - 1 do
            FileAddToList(CFList.Strings[Cnt]);
      finally
        CFList.Free;
      end;
    end;
end;

procedure TDMain.DeleteItemExecute(Sender: TObject);
var Idx: integer;
begin
    with DList do begin
      if SelCount = 0 then Exit;
      Idx := Selected.Index;
      Items.BeginUpdate;
      while Idx < Items.Count do
        if (Items[Idx].Selected) and
           (Items[Idx].SubItems[0] <> 'Decoding...') then
          Items.Delete(Idx)
        else
          Inc(Idx);
      Items.EndUpdate;
    end;
end;

procedure TDMain.ListItemMove(MoveCount: integer);
var Cnt: integer;
    NewItem: TListItem;
begin
    with DList do begin
      if (SelCount = 0) or (MoveCount = 0) then Exit;
      if MoveCount < 0 then begin
        Cnt := Selected.Index;
        if Cnt + MoveCount < 0 then Exit;
        Items.BeginUpdate;
        while Cnt < Items.Count do begin
          if Items[Cnt].Selected then begin
            NewItem := Items.Insert(Cnt + MoveCount);
            NewItem.Assign(Items[Cnt + 1]);
            Items[Cnt + MoveCount].Selected := True;
            Items.Delete(Cnt + 1);
          end
          else
            Inc(Cnt);
        end;
        Items.EndUpdate;
      end
      else begin
        Cnt := Items.Count - 1;
        while Cnt > -1 do
          if Items[Cnt].Selected then
            Break
          else
            Dec(Cnt);
        if Cnt + MoveCount > Items.Count - 1 then Exit;
        Items.BeginUpdate;
        while Cnt > -1 do begin
          if Items[Cnt].Selected then begin
            NewItem := Items.Insert(Cnt + MoveCount + 1);
            NewItem.Assign(Items[Cnt]);
            Items[Cnt + MoveCount + 1].Selected := True;
            Items.Delete(Cnt);
          end
          else
            Dec(Cnt);
        end;
        Items.EndUpdate;
      end;
    end;
end;

procedure TDMain.UpItemExecute(Sender: TObject);
begin
    if (Sender as TAction) = UpItem then
      ListItemMove(-1) else ListItemMove(1);
end;

procedure TDMain.DListDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var TargetItem: TListItem;
begin
    Accept := False;
    TargetItem := DList.GetItemAt(X,Y);
    if (TargetItem <> nil) and (TargetItem.Index <> dgIdx) then begin
      dgIdx  := DList.ItemFocused.Index;
      Accept := True;
    end;
end;

procedure TDMain.DListDragDrop(Sender, Source: TObject; X, Y: Integer);
var TargetItem: TListItem;
begin
    TargetItem := DList.GetItemAt(X,Y);
    ListItemMove(TargetItem.Index - dgIdx);
end;

procedure TDMain.OpenSourceDirExecute(Sender: TObject);
var Dir: string;
begin
    with TdfsBrowseDirectoryDlg.Create(Self) do begin
      try
        ShowSelectionInStatus := true;
        Caption := 'tH_̑I';
        Title   := 'wtH_̃t@CXgɒǉ';
        Selection := Main.DefaultDir;
        if Execute then begin
          Dir := Selection;
          if Copy(Dir, Length(Dir), 1) <> '\' then
            Dir := Dir + '\';
          DirAddToList(Dir);
          Main.DefaultDir := Dir;
        end;
      finally
        Free;
      end;
    end;
end;

procedure TDMain.DirAddToList(SrcDir: string);
var DirList: TStringList;
    SearchRec:TSearchRec;
    FileFound:Boolean;
    Cnt: integer;
begin
    DirList := TStringList.Create;
    try
      if SrcDir[Length(SrcDir)] <> '\' then SrcDir := SrcDir + '\';
      FileFound := (0 = FindFirst(SrcDir + '*.mp3', faAnyfile, SearchRec));
      try
        while FileFound do begin
          with SearchRec do
            if (Name <> '.') and (Name <> '..') then
              DirList.Add(SrcDir + Name);
          FileFound := (0 = FindNext(SearchRec));
        end;
      finally
        FindClose(SearchRec);
      end;
      if DirList.Count > 0 then
        for Cnt := 0 to DirList.Count - 1 do
          FileAddToList(DirList.Strings[Cnt]);
    finally
      DirList.Free;
    end;
end;

procedure TDMain.Exit1Click(Sender: TObject);
begin
    close;
end;

procedure TDMain.FormCreate(Sender: TObject);
    procedure AddPopMenu;
    var Idx: integer; AddMnuItm: TMenuItem;
    begin
        for Idx := 0 to 5 do begin
          AddMnuItm        := TMenuItem.Create(Self);
          AddMnuItm.Action := ActionList1.Actions[Idx];
          DecPop.Items.Add(AddMnuItm);
        end;
        AddMnuItm         := TMenuItem.Create(Self);
        AddMnuItm.Caption := '-';
        DecPop.Items.Insert(2,AddMnuItm);
        AddMnuItm         := TMenuItem.Create(Self);
        AddMnuItm.Caption := '-';
        DecPop.Items.Insert(4,AddMnuItm);
        AddMnuItm         := TMenuItem.Create(Self);
        AddMnuItm.Caption := '-';
        DecPop.Items.Insert(7,AddMnuItm);
    end;
var Cnt: integer;
begin
    UpItem.ShortCut       := ShortCut(Word(VK_UP)  ,[ssCtrl]);
    DownItem.ShortCut     := ShortCut(Word(VK_DOWN),[ssCtrl]);
    EditItem.ShortCut     := ShortCut(Word(VK_RETURN),[ssShift]);
    SelectItem.ShortCut   := ShortCut(Word(VK_SPACE),[ssShift]);
    DeselectItem.ShortCut := ShortCut(Word(VK_SPACE),[ssCtrl]);
    EList := TList.Create;

    Prg := TProgressBar.Create(Self);
    with Prg do begin
      Parent  := StatusBar1;
      Anchors := [akLeft,akTop];
      Top     := 2;  Left := 0; Height := 18;
      Max     := 110; Min := 0; Step := 8;
      Visible := True;
    end;
    DecPop := TPopupMenu.Create(Self);
    AddPopMenu;
    DList.PopupMenu := DecPop;

    OldFileName := Main.MP3Player1.FileName;
    if Main.MP3Player1.IsOpen then begin
      Main.MP3Player1.Close;
      //MPLAY.Clear;
    end;
    DMP3 := Main.MP3Player1;
    Main.MP3Player1.OnChangePosition := DMP3ChangePosition;
    Main.MP3Player1.OnEndPlay        := DMP3EndPlay; 

    if Length(Main.DecDesArr) > 0 then begin
      for Cnt := 0 to Length(Main.DecDesArr) - 1 do
        //FolderBox.Items.Add(Main.DecDesList.Strings[Cnt]);
        FolderBox.Items.Add(Main.DecDesArr[Cnt]);
      if (Main.DecDesIdx > -1) and (Main.DecDesIdx < FolderBox.Items.Count) then
        FolderBox.ItemIndex := Main.DecDesIdx
      else
        FolderBox.ItemIndex := FolderBox.Items.Count - 1;
    end;

    if Main.ListView1.Items.Count > 0 then
      for Cnt := 0 to Main.ListView1.Items.Count - 1 do
        if Main.ListView1.Items[Cnt].Selected then
          FileAddToList(Main.ListView1.Items[Cnt].SubItems[7]);

    Self.Left := (Screen.Width  - Self.Width)  div 2;
    Self.Top  := (Screen.Height - Self.Height) div 2;
end;

procedure TDMain.AbortItemExecute(Sender: TObject);
begin
    if (DMP3.FileName <> '') and (EList.Count > 0) and
       (DMP3.IsOpen) then begin
      TListItem(EList[0]).Checked     := False;
      TListItem(EList[0]).SubItems[0] := 'Aborted';
    end;
    DMP3.OnEndPlay := nil;
    DecEnd         := True;
    DMP3.Pause;
    DMP3.Close;
    DecodeItem.Enabled := True;
    DecEnd             := False;
end;

procedure TDMain.DecodeUnderEntry;
var Cnt: integer;
    SrcStr,DesStr: string;
begin
    DecEnd := False;
    with DList do begin
      if Items.Count = 0 then Exit;
      Cnt := 0;
      SrcStr := '';
      DesStr := '';
      EList.Clear;
      while Cnt < Items.Count do
        if (Items[Cnt].Checked) and
           (Items[Cnt].SubItems[0]='') then begin
          SrcStr := Items[Cnt].SubItems[2];
          DesStr := Items[Cnt].SubItems[1];
          EList.Add(Items[Cnt]);
          Break;
        end
        else
          Inc(Cnt);
      if SrcStr = '' then Exit;
      DMP3.FileName := SrcStr;
      DMP3.Open;
      DMP3.PlayToFile(DesStr);
      Items[Cnt].SubItems[0] := 'Decoding...';
    end;
end;

procedure TDMain.FormDestroy(Sender: TObject);
begin
    Prg.Free;
    EList.Free;
    DecPop.Free;
end;

procedure TDMain.DecodeItemExecute(Sender: TObject);
begin
    DMP3.OnEndPlay := DMP3EndPlay;
    DecodeUnderEntry;
end;

procedure TDMain.DMP3EndPlay(Sender: TObject;
  Reason: TMP3EndPlayReason);
begin
    if (DMP3.FileName <> '') and (EList.Count > 0) then begin
      TListItem(EList[0]).Checked := False;
      TListItem(EList[0]).SubItems[0] := 'Done';
    end;
    if DMP3.IsOpen then DMP3.Close;
    if not DecEnd then
      DecodeUnderEntry;
end;

procedure TDMain.PasteItemUpdate(Sender: TObject);
begin
    PasteItem.Enabled := (Clipboard.AsText <> '');
end;

procedure TDMain.EditItemExecute(Sender: TObject);
var Cnt: integer;
    OldDes: string;
begin
    with DList do begin
      if SelCount = 0 then Exit;
      for CNt := Selected.Index to Items.Count - 1 do
        if Items[Cnt].Selected then begin
          OldDes := Items[Cnt].SubItems[1];
          if InputQuery('Rename OutPut FileName', 'New Output', OldDes) then begin
            if Items[Cnt].SubItems[1] <> Trim(OldDes) then
              Items[Cnt].SubItems[0] := '';
            Items[Cnt].SubItems[1] := Trim(OldDes);
          end;
        end;
    end;
end;

procedure TDMain.DMP3ChangePosition(Sender: TObject);
begin
    if DMP3.Length = 0 then
      Prg.Position := 0
    else
      Prg.Position := Trunc((DMP3.Position / DMP3.Length) * 100);
end;

procedure TDMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Main.DecDesIdx := FolderBox.ItemIndex;
    DMP3                             := nil;
    Main.MP3Player1.FileName         := OldFileName;
    Main.MP3Player1.OnChangePosition := nil;
    Main.MP3Player1.OnEndPlay        := Main.MP3Player1EndPlay;
    Action                           := caFree;
end;

{procedure TDMain.CopyItemExecute(Sender: TObject);
var Cnt: integer;
    CL: TStringList;
begin
    if DList.SelCount = 0 then Exit;
    CL := TStringList.Create;
    try
      for Cnt := DLIst.Selected.Index to DList.Items.Count - 1 do
        if DList.Items[Cnt].Selected then
          CL.Add(DList.Items[Cnt].SubItems[2]);
      if CL.Count > 0 then
        Clipboard.AsText := CL.Text;
    finally
      CL.Free;
    end;
end;}

procedure TDMain.DListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if DList.SelCount = 1 then begin
    StatusBar1.Panels[1].Text := Item.SubItems[2];
  end
  else begin
    StatusBar1.Panels[1].Text := '';
  end;
end;

procedure TDMain.ChangeFolderExecute(Sender: TObject);
var Dir: string;
    Cnt: integer;
begin
  if DList.SelCount > 0 then begin
    with TdfsBrowseDirectoryDlg.Create(Self) do begin
      try
        ShowSelectionInStatus := true;
        Caption := 'tH_̑I';
        Title   := 'IACeWAVo̓tH_ύX';
        Selection := ExtractFilePath(DList.Selected.SubItems[1]);
        if Execute then begin
          Dir := IncludeTrailingBackslash(Selection);
          for Cnt := DList.Selected.Index to DList.Items.Count - 1 do begin
            if DList.Items[Cnt].Selected then begin
              DList.Items[Cnt].SubItems[1] := Dir + ExtractFileName(DList.Items[Cnt].SubItems[1]);
            end;
          end;
        end;
      finally
        Free;
      end;
    end;
  end;
end;

procedure TDMain.ClearStatusExecute(Sender: TObject);
var Cnt: integer;
begin
  if DList.SelCount > 0 then begin
    for Cnt := DList.Selected.Index to DList.Items.Count - 1 do begin
      if (DList.Items[Cnt].Selected) and
         (DList.Items[Cnt].SubItems[0] <> 'Decoding...') then begin
        DList.Items[Cnt].SubItems[0] := '';
      end;
    end;
  end;
end;

end.
