program Wyvern;

uses
  //MemCheck,
  Forms,
  Windows,
  Classes,
  Messages,
  SysUtils,
  CopyOwnData,
  wyvMain in 'wyvMain.pas' {Main},
  wyvSub in 'wyvSub.pas' {Sub},
  wyvTag in 'wyvTag.pas' {TagForm},
  wyvPref in 'wyvPref.pas' {PreForm},
  wyvEq in 'wyvEq.pas' {EqForm},
  wyvFav in 'wyvFav.pas' {FavForm},
  Unit1 in 'Unit1.pas' {DMain},
  wyvVPCtrl in 'wyvVPCtrl.pas' {VPForm},
  wyvResStr in 'wyvResStr.pas',
  MyFunc in 'MyFunc.pas',
  EqlzCtrl in 'EqlzCtrl.pas',
  ID3TagControl in 'ID3TagControl.pas';

{$R *.RES}

var
  hMutex: THandle;
  Cnt: integer;
  SendData: TSendData;
  PrmList: TStringList;
  Oldhwnd,Subhnd: hwnd;

const wyvMutexStr: string = 'Wyvern';

begin
  hMutex := OpenMutex(MUTEX_ALL_ACCESS, false, PChar(wyvMutexStr));
  if hMutex <> 0 then begin
    try
      Oldhwnd := 0;
      if ParamCount > 0 then begin
         PrmList := TStringList.Create;
         try
            for Cnt := 1 to ParamCount do
              PrmList.Add(ParamStr(Cnt));
            SendData := TSendData.Create(wyvMemName);
            try
              with SendData do begin
                OwnHnd := Application.Handle;
                GetTargetHandle;
                Oldhwnd := SendData.TargetHandle;
                SaveComMem(PrmList);
                SendOwnMessage;
              end;
            finally
              SendData.Free;
            end;
         finally
           PrmList.Free;
         end;
      end;
      if Oldhwnd <> 0 then begin
        Subhnd:=FindWindow(nil,'Sub');
        if (Subhnd<>0) and (IsWindowVisible(Subhnd)) then
          SetForegroundWindow(Subhnd)
        else
        if IsWindowVisible(Oldhwnd) then begin
          SetForegroundWindow(Oldhwnd);
          SendMessage(Oldhwnd, WM_USER + $0800, 0, 0);
        end;
      end;
    finally
      CloseHandle(hMutex);
    end;
  end
  else begin
    hMutex := CreateMutex(nil, false, PChar(wyvMutexStr));
    try
      Application.Initialize;
      Application.Title := 'Wyvern';
      HotStat           := hsNormal;
      Application.CreateForm(TMain, Main);
      Application.CreateForm(TSub, Sub);
      if (Main.GNOpt[_GN_STRTTRAY]) or
         (IsMiniView) or (Main.GNOpt[_GN_STRTMINI]) then begin
        if Main.GNOpt[_GN_STRTTRAY] then
          HotStat := hsTask;
        Application.ShowMainForm := false;
      end;
      Application.Run;
    finally
    	ReleaseMutex(hMutex);
    end;
  end;
end.
