{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}
unit wyvEq;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, MyFunc, CheckLst, EqlzCtrl, Menus, ToolWin, ExtCtrls,
  Spin, ActnList, ShellAPI;

type
  TEqForm = class(TForm)
    ToolBar1: TToolBar;
    ImportEq: TToolButton;
    AddEqSet: TToolButton;
    DelEqSet: TToolButton;
    RenEqSet: TToolButton;
    ToolButton5: TToolButton;
    EnableEq: TCheckBox;
    InitialButton: TToolButton;
    Panel1: TPanel;
    BalanceLabel: TLabel;
    eachLvlLabel: TLabel;
    eqlvlLabel: TLabel;
    DefFrqLabel: TLabel;
    TrackBar11: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    TrackBar9: TTrackBar;
    TrackBar10: TTrackBar;
    ItemUpDownButton: TSpinButton;
    EqLV: TListView;
    EqPopupMenu: TPopupMenu;
    EqAction: TActionList;
    actEqExportAll: TAction;
    actImport: TAction;
    actAddEqSetting: TAction;
    actEqRename: TAction;
    actEqDelete: TAction;
    actImport1: TMenuItem;
    Export1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Rename1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EnableEqClick(Sender: TObject);
    procedure EqNameBoxChange(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar11Change(Sender: TObject);
    procedure InitialButtonClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ItemUpDownButtonDownClick(Sender: TObject);
    procedure ItemUpDownButtonUpClick(Sender: TObject);
    procedure EqLVCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure EqLVDblClick(Sender: TObject);
    procedure EqLVEdited(Sender: TObject; Item: TListItem; var S: String);
    procedure EqLVMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EqLVDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure EqLVDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actImportExecute(Sender: TObject);
    procedure actAddEqSettingExecute(Sender: TObject);
    procedure actEqRenameExecute(Sender: TObject);
    procedure actEqDeleteExecute(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure actEqExportAllExecute(Sender: TObject);
    procedure EqLVKeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
    DragLI: TListItem;
    procedure ViewValueLabel;
    procedure ViewValanceLabel;
    procedure UpDownCheckBoxItem(IsItemUp: Boolean);
    procedure EqualizerFileImport(FileName: string);
    procedure RefreshEqLVCaption;
  public
    { Public 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
  end;

var
  EqForm: TEqForm;

implementation

uses wyvMain,wyvResStr,mp3plyr;

{$R *.DFM}

{ TEqForm }


procedure TEqForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.WndParent  :=  Main.Handle;
    Params.ExStyle    :=  Params.EXStyle or WS_EX_ACCEPTFILES;
end;

procedure TEqForm.FormCreate(Sender: TObject);
var Cnt: integer;
begin
    if not Main.staytop.Down then
      Self.FormStyle := fsNormal;
    with Self do begin
      if Main.EqLeft <> 0 then
        Left := Main.EqLeft
      else
        Left := (Screen.Width - Width)  div 2;
      if Main.EqTop <> 0 then
        Top := Main.EqTop
      else
        Top  := (Screen.Height - Top)  div 2; end;

    for Cnt := 1 to 11 do
      SetTrackBarFace(TTrackBar(Self.FindComponent('TrackBar' + IntToStr(Cnt))));

    for Cnt := 0 to Length(EqCtrl.FANamLst) - 1 do begin
      with EqLV.Items.Add do
        Caption := EqCtrl.FANamLst[Cnt];
    end;

    EqCtrl.SetEqFromList(EqCtrl.CurrentIdx);

    for Cnt := 1 to Main.MP3Player1.EqualizerCount do
      (Self.FindComponent('TrackBar' + IntToStr(Cnt)) as TTrackBar).Position :=
        -Main.MP3Player1.Equalizer[Cnt - 1];
    if not Main.MP3Player1.EqualizerEnabled then begin
      EnableEq.Checked := False;
      EnableEqClick(nil);
    end;
    eqlvlLabel.Caption := '+20dB' + #13#10#13#10#13#10 +
                          '  0dB' + #13#10#13#10#13#10 + '-20dB';
    if Main.tmp_Eq <> '' then begin
      DefFrqLabel.Caption := 'Changed';
      DefFrqLabel.Hint    := Main.tmp_Eq;
    end;
    ViewValanceLabel;
    ViewValueLabel;
end;

procedure TEqForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Main.EqTop         := Self.Top;
    Main.EqLeft        := Self.Left;
    Action             := caFree;
    Main.EqButton.Down := False;
end;

procedure TEqForm.EnableEqClick(Sender: TObject);
var IsEq: Boolean; Cnt: integer;
begin
    IsEq                   := EnableEq.Checked;
    //EqNameCheckBox.Enabled := IsEq;
    EqLV.Enabled           := IsEq;
    AddEqSet.Enabled       := IsEq;
    DelEqSet.Enabled       := IsEq;
    RenEqSet.Enabled       := IsEq;
    ImportEq.Enabled       := IsEq;
    BalanceLabel.Enabled   := IsEq;
    InitialButton.Enabled  := IsEq;
    eachLvlLabel.Enabled   := IsEq;
    eqlvlLabel.Enabled     := IsEq;
    DefFrqLabel.Enabled    := IsEq;
    for Cnt := 1 to 11 do
      (Self.FindComponent('TrackBar' + IntToStr(Cnt)) as TTrackBar).Enabled := IsEq;
    EqCtrl.EnableEq := IsEq;
end;

procedure TEqForm.EqNameBoxChange(Sender: TObject);
var Cnt: integer;
begin
    //EqCtrl.SetEqFromList(EqNameCheckBox.ItemIndex);
    EqCtrl.SetEqFromList(EqCtrl.CurrentIdx);
    for Cnt := 1 to 10 do
      (Self.FindComponent('TrackBar' + IntToStr(Cnt)) as TTrackBar).Position
        := -Main.MP3Player1.Equalizer[Cnt - 1];
    TrackBar11.Position := Main.MP3Player1.VolBalance;
    ViewValanceLabel;
    ViewValueLabel;
end;

procedure TEqForm.TrackBar1Change(Sender: TObject);
begin
    Main.MP3Player1.Equalizer[(Sender as TTrackBar).Tag] := -(Sender as TTrackBar).Position;
    ViewValueLabel;
    //EqCtrl.SaveCurrentEachValue(EqNameCheckBox.ItemIndex, (Sender as TTrackBar).Tag);
    EqCtrl.SaveCurrentEachValue(EqCtrl.CurrentIdx, (Sender as TTrackBar).Tag);
end;

procedure TEqForm.ViewValueLabel;
var eqIdx,eqnow: integer;
    eqFlg,LblCap: string;
begin
    for eqIdx := 0 to 9 do begin
      eqnow := Main.MP3Player1.Equalizer[eqIdx];
      if eqnow >= 0 then
        eqFlg := '+' + IntToStr(eqnow)
      else
        eqFlg := IntToStr(eqnow);
      LblCap := LblCap + StringofChar(' ', 4 - Length(eqFlg)) + eqFlg;
    end;
    eachLvlLabel.Caption := LblCap;
end;

procedure TEqForm.ViewValanceLabel;
var eqFlg: string;
begin
    if TrackBar11.Position >= 0 then
      eqFlg := '+' + IntToStr(Main.MP3Player1.VolBalance)
    else
      eqFlg := IntToStr(Main.MP3Player1.VolBalance);
    BalanceLabel.Caption := 'Balance ' + eqFlg;
end;

procedure TEqForm.TrackBar11Change(Sender: TObject);
begin
    Main.MP3Player1.VolBalance := TrackBar11.Position;
    ViewValanceLabel;
    //EqCtrl.SaveCUrrentEachValue(EqNameCheckBox.ItemIndex, (Sender as TTrackBar).Tag);
    EqCtrl.SaveCUrrentEachValue(EqCtrl.CurrentIdx, (Sender as TTrackBar).Tag);
end;

procedure TEqForm.InitialButtonClick(Sender: TObject);
var Cnt: integer;
begin
     for Cnt := 1 to 11 do
       TTrackBar(FindComponent('TrackBar' + IntToStr(Cnt))).Position := 0;
     for Cnt := 0 to Main.MP3Player1.EqualizerCount - 1 do
       Main.MP3Player1.Equalizer[Cnt] := 0;
     Main.MP3Player1.VolBalance := 0;
     ViewValanceLabel;
     ViewValueLabel;
     //EqCtrl.SaveCurrentValue(EqNameCheckBox.ItemIndex);
     EqCtrl.SaveCurrentValue(EqCtrl.CurrentIdx);
end;

procedure TEqForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) then begin Key := Word(#0); Close; end;
end;

procedure TEqForm.ItemUpDownButtonDownClick(Sender: TObject);
begin
  UpDownCheckBoxItem(false);
end;

procedure TEqForm.ItemUpDownButtonUpClick(Sender: TObject);
begin
  UpDownCheckBoxItem(true);
end;

procedure TEqForm.UpDownCheckBoxItem(IsItemUp: Boolean);
var
  Idx1, Idx2, chkIdx: integer;
  CheckOnMove: boolean;
  s: string;
begin
    with EqLV do begin
      if Selected = nil then exit;
      if IsItemUp then
        Idx1 := Selected.Index - 1
      else
        Idx1 := Selected.Index + 1;
      if (Idx1 < 1) or (Idx1 > Items.Count - 1) then exit;
      Idx2 := Selected.Index;
      chkIdx := Idx1;
      CheckOnMove := true;
      if Idx1 = EqCtrl.CurrentIdx then
        chkIdx := Idx2
      else
        CheckOnMove := false;
      s := Items[Idx1].Caption;
      Items[Idx1].Caption := Items[Idx2].Caption;
      Items[Idx2].Caption := s;
      Items[Idx1].Selected := true;
      //EqLV.Refresh;
      EqCtrl.SwapEqItem(Idx1, Idx2);
      //Items.Exchange(Idx1, Idx2);
      if CheckOnMove then begin
        //EqCtrl.CurrentIdx :=
        EqCtrl.SetEqFromList(chkIdx);
      end;
    end;
end;


procedure TEqForm.EqLVCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var ARect: TRect;
begin
  ARect := Item.DisplayRect(drBounds);
  EqLV.Canvas.Refresh;
  EqLV.Canvas.Font.Assign(EqLV.Font);
  if Item.Index <> EqCtrl.CurrentIdx then
    EqLV.Canvas.Font.Color := clBlack
  else
    EqLV.Canvas.Font.Color := clBlue;
  Sender.Canvas.FillRect(ARect);
  Sender.Canvas.TextRect(ARect, ARect.Left, ARect.Top, Item.Caption);
end;

procedure TEqForm.EqLVDblClick(Sender: TObject);
begin
  with EqLV do begin
    if Selected <> nil then begin
      EqCtrl.CurrentIdx := Selected.Index;
      EqLV.Refresh;
      EqNameBoxChange(nil);
    end;
  end;
end;

procedure TEqForm.EqLVEdited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  Item.Caption := S;
  EqCtrl.AddArryFromCommaStr(S, '', Item.Index);
end;

procedure TEqForm.EqLVMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    DragLI := EqLV.GetItemAt(X, Y);
    if (DragLI <> nil) and (DragLI.Index > 0) then
      EqLV.BeginDrag(false);
  end;
end;

procedure TEqForm.EqLVDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var DropLI: TListItem;
begin
  Accept := false;
  DropLI := EqLV.GetItemAt(X, Y);
  if (DropLI <> nil) and
     (DropLI <> DragLI) and
     (DropLI.Index > 0) then
    Accept := true;
end;

procedure TEqForm.EqLVDragDrop(Sender, Source: TObject; X, Y: Integer);
var InsLI, DropLI: TListItem;
  CurrEqIdx, DrgIdx, DrpIdx: integer;
begin
  DropLI := EqLV.GetItemAt(X, Y);
  EqLV.Items.BeginUpdate;
  try
    CurrEqIdx := Eqctrl.CurrentIdx;
    DrgIdx := DragLI.Index;
    DrpIdx := DropLI.Index;
    if DragLI.Index = CurrEqIdx then
      CurrEqIdx := DropLI.Index
    else
    if (CurrEqIdx <= DropLI.Index) and
       (CurrEqIdx > DragLI.Index) then
      Dec(CurrEqIdx)
    else
    if (CurrEqIdx >= DropLI.Index) and
       (CurrEqIdx < DragLI.Index) then
      Inc(CurrEqIdx);
    if DropLI.Index > DragLI.Index then
      InsLI := EqLV.Items.Insert(DropLI.Index + 1)
    else
      InsLI := EqLV.Items.Insert(DropLI.Index);
    InsLI.Assign(DragLI);
    DragLI.Free;
    EqLV.Checkboxes := false;
    EqCtrl.MoveEqItem(DrgIdx, DrpIdx);
    EqCtrl.CurrentIdx := CurrEqIdx;
  finally
    EqLV.Items.EndUpdate;
  end;
  EqLV.Refresh;
end;

procedure TEqForm.RefreshEqLVCaption;
var Idx, Cnt: integer;
begin
  Idx := EqLV.Items.Count;
  if Idx < Length(EqCtrl.FANamLst) then begin
    for Cnt := Idx to High(EqCtrl.FANamLst) do
      EqLV.Items.Add.Caption := EqCtrl.FANamLst[Cnt];
  end;
end;

procedure TEqForm.EqualizerFileImport(FileName: string);
var extstr: string;
begin
  extstr := LowerCase(ExtractFileExt(FileName));
  if extstr = '.weq' then
    EqCtrl.ImportWEQFile(FileName)
  else
  if (extstr = '.eqf') or
     ((Length(extstr) = 3) and (extstr[2] = 'q')) then
    EqCtrl.ImportEqFile(FileName);
end;

procedure TEqForm.actImportExecute(Sender: TObject);
var Cnt: integer;
begin
    with TOpenDialog.Create(Self) do begin
      try
      Filter :=
      'Winamp EQ File(*.q?,*.eqf)|*.q?;*.eqf|Wyvern EQ File(*.weq)|*.weq';
      InitialDir := Main.DefaultDir;
      Options := Options + [ofAllowMultiSelect];
      if Execute then begin
        for Cnt := 0 to Files.Count - 1 do begin
          EqualizerFileImport(Files[Cnt]);
        end;
      end;
      finally
        Free;
      end;
    end;
    RefreshEqLVCaption;
end;

procedure TEqForm.actAddEqSettingExecute(Sender: TObject);
var Cnt: integer;
    AddLI: TListItem;
begin
     if Main.staytop.Down then Main.NoTopMost(Main.Handle);
     try
       AddLI := EqLV.Items.Add;
       EqCtrl.SaveNameAndValue('', nil);
       for Cnt := 0 to EqLV.Items.Count - 1 do
         EqLV.Items[Cnt].Checked := false;
       AddLI.Checked  := true;
       AddLI.Selected := true;
       AddLI.EditCaption;
     finally
       if Main.staytop.Down then Main.TopMost(Main.Handle);
     end;
end;

procedure TEqForm.actEqRenameExecute(Sender: TObject);
begin
  with EqLV do begin
    if (Selected = nil) or (Selected.Index = 0) then exit;
    Selected.EditCaption;
  end;
end;

procedure TEqForm.actEqDeleteExecute(Sender: TObject);
var Cnt: integer;
begin
    if EqLV.Selected = nil then exit;
    if Main.staytop.Down then Main.NoTopMost(Main.Handle);
    try
      if (not Main.PLOpt[2]) and
         (Application.MessageBox(
              PChar(EqLV.Selected.Caption + '폜܂'),
              'CRCU[ݒ̍폜', MB_YESNO + MB_ICONWARNING) <> IDYES) then exit;
      if EqCtrl.DeleteNameAndValue(EqLV.Selected.Index) then begin
        EqLV.Items.Delete(EqLV.Selected.Index);
        for Cnt := 0 to EqLV.Items.Count - 1 do
          EqLV.Items[Cnt].Checked := (Cnt = EqCtrl.CurrentIdx);
        EqNameBoxChange(nil);
      end;
    finally
      if Main.staytop.Down then Main.TopMost(Main.Handle);
    end;
end;

procedure TEqForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TEqForm.actEqExportAllExecute(Sender: TObject);
var svName: string;
    svList: TStringList;
    Cnt: integer;
begin
  with TSaveDialog.Create(Self) do begin
    try
      Filter :=
      'Wyvern EQ File(*.weq)|*.weq';
      DefaultExt := 'weq';
      Title      := 'CRCU[ݒweq`ŕۑ';
      Options    := Options + [ofOverwritePrompt];
      InitialDir := Main.DefaultDir;
      if Execute then begin
        svName := FileName;
        svList := TStringList.Create;
        try
          for Cnt := 0 to EqLV.Items.Count - 1 do begin
            svList.Add(EqLV.Items[Cnt].Caption + '=' + EqCtrl.GetValueStr(Cnt));
          end;
          svList.SaveToFile(svName);
        finally
          svList.Free;
        end;
      end;
    finally
      Free;
    end;
  end;
end;

procedure TEqForm.WMDropFiles(var Msg: TWMDropFiles);
var FileIndex, FileNameLength: Cardinal;
    FileCount: Cardinal;
    FileName: string;
begin
     FileCount := 0;
     try
       FileCount := DragQueryFile(Msg.Drop, $ffffffff, nil, 0);
       if FileCount > 0 then begin
         for FileIndex := 0 to FileCount - 1 do begin
           FileNameLength := DragQueryFile(Msg.Drop, FileIndex, nil, 0);
           SetLength(FileName, FileNameLength);
           DragQueryFile(Msg.Drop, FileIndex, PChar(FileName), FileNameLength + 1);
           EqualizerFileImport(FileName);
         end;
       end;
     finally
       DragFinish(Msg.Drop);
     end;
     RefreshEqLVCaption;
end;

procedure TEqForm.EqLVKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = #13) and (EqLV.SelCount = 1) then begin
    Key := #0;
    EqLVDblClick(nil);
  end;
end;

end.
