{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}
unit wyvTag;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, MP3Plyr,
  ID3TagControl, StdCtrls, Spin, ExtCtrls;

type
  TTagForm = class(TForm)
    Panel1: TPanel;
    Label8: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    EditTitle: TEdit;
    Combo0: TComboBox;
    Combo1: TComboBox;
    ComboYear: TComboBox;
    Combo2: TComboBox;
    ComboGenre: TComboBox;
    IsTrack: TCheckBox;
    EditTrack: TSpinEdit;
    WriteButton: TButton;
    CancelButton: TButton;
    srcLabel: TEdit;
    Label13: TLabel;
    procedure WriteButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IsTrackClick(Sender: TObject);
  private
    { Private 錾 }
    srcFile: string;
    procedure ReadFileTag(FileName: string);
    procedure WriteFileTag;
  public
    { Public 錾 }
    constructor CreateForFile(OWner: TComponent;
    FileName: string; IsOwnTrack: Boolean);
  end;

var
  TagForm: TTagForm;

implementation

uses wyvMain;

{$R *.DFM}


{ TTagForm }

constructor TTagForm.CreateForFile(OWner: TComponent; FileName: string; IsOwnTrack: Boolean);
var Attr, i, Cnt: integer;
    TagCombo: TComboBox;
begin
    inherited Create(OWner);
    for Cnt := 0 to 255 do
      ComboGenre.Items.Add(GenreTbl[Cnt]);

    srcFile             := FileName;
    srcLabel.Text       := srcFile;
    srcLabel.Hint       := srcFile;
    Attr                := FileGetAttr(srcFile);
    WriteButton.Enabled := ((Attr and faReadOnly) = 0) and (IsOwnTrack);
    for i := 0 to 2 do begin
      if Length(TagArray[i]) > 0 then begin
        TagCombo := (FindComponent('Combo' + IntToStr(i)) as TComboBox);
        for Cnt := 0 to Length(TagArray[i]) - 1 do
          TagCombo.Items.Add(TagArray[i][Cnt]);
      end;
    end;
    if Length(YearTag) > 0 then
      for Cnt := 0 to Length(YearTag) - 1 do
        ComboYear.Items.Add(YearTag[Cnt]);
    ReadFileTag(srcFile);
end;

procedure TTagForm.ReadFileTag(FileName: string);
var Info: TMP3Info;
begin
    Info := TMP3Info.Create;
    Main.MP3Player1.ReadInfo(FileName,Info);
    try
      with Info.ID3V1Infos do begin
        EditTitle.Text    := Values['TITLE'];
        Combo0.Text       := Values['ARTIST'];
        Combo1.Text       := Values['ALBUM'];
        ComboYear.Text    := Values['YEAR'];
        Combo2.Text       := Values['COMMENT'];
        IsTrack.Checked   := (Values['TRACK'] <> '');
        EditTrack.Enabled := IsTrack.Checked;
        if IsTrack.Checked then
          EditTrack.Text := Values['TRACK'];
      end;
      ComboGenre.ItemIndex := Info.GenreIndex;
    finally
      Info.Free;
    end;
end;

procedure TTagForm.WriteFileTag;
var Fst: TID3Tags;
begin
    Fst := TID3Tags.Create(srcLabel.Text);
    try
      // title
      Fst.Title   := EditTitle.Text;
      // Artist
      Fst.Artist  := Combo0.Text;
      // Album
      Fst.Album   := Combo1.Text;
      // Year
      Fst.Year    := ComboYear.Text;
      // Comment
      Fst.Comment := Combo2.Text;
      // Genre
      Fst.Genre   := byte(ComboGenre.ItemIndex);
      if IsTrack.Checked then
        Fst.Track := EditTrack.Value;
      Fst.WriteTags(IsTrack.Checked);
    finally
      Fst.Free;
    end;
end;

procedure TTagForm.WriteButtonClick(Sender: TObject);
  procedure TagArrayItemAdd(s: string; Idx: integer);
  begin
    case Idx of
        -1: begin
              SetLength(YearTag, Length(YearTag) + 1);
              YearTag[Length(YearTag) - 1] := s;
            end;
      0..2: begin
              SetLength(TagArray[Idx], Length(TagArray[Idx]) + 1);
              TagArray[Idx][Length(TagArray[Idx]) - 1] := s;
            end;
    end;
  end;
  procedure ComboItemAdd(ACombo: TComboBox; Idx: integer);
  var s: string;
  begin
    with ACombo do begin
      s := Trim(Text);
      if (s <> '') and (Items.IndexOf(s) = -1) then begin
        Items.Add(Copy(s, 0, ACombo.Tag));
        TagArrayItemAdd(s, Idx);
      end;
    end;
  end;
var i: integer;
begin
    for i := 0 to 2 do begin
      ComboItemAdd((FindComponent('Combo' + IntToStr(i)) as TComboBox), i);
    end;
    ComboItemAdd(ComboYear, -1);
    if (ComboGenre.ItemIndex = -1) then begin
      ShowMessage('WIĂ܂');
      Exit;
    end;
    WriteFileTag;
    close;
end;

procedure TTagForm.CancelButtonClick(Sender: TObject);
begin
    close;
end;

procedure TTagForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action:=caFree;
end;

procedure TTagForm.IsTrackClick(Sender: TObject);
begin
  if WriteButton.Enabled then
    EditTrack.Enabled := IsTrack.Checked;
end;

end.
