
{
  Wyvern (C)1999-2001 MinMin

  ̃vO̓t[\tgłAۏ؂łB
  GPLɊÂẴvOgpEύXEĔzt邱Ƃo܂B
  ڂGNUʌLgpǂ݂B
  R|[lgɊւĂ͈ȉ̒쌠܂܂܂B

  This program is free software;
  you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with this program;
  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
  Suite 330, Boston, MA 02111-1307 USA

  Copyright (C) 1999 Xing Technology, GoodNoise, Jean-Michel HERVE, Kei Ishida.

}

unit wyvVPCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, MyFunc;

type
  TVPForm = class(TForm)
    VolBar: TTrackBar;
    PosBar: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure VolBarChange(Sender: TObject);
    procedure PosBarChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure VPChangePos(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams);override;
  end;

var
  VPForm: TVPForm;

implementation

uses wyvMain;

{$R *.DFM}

{ TVPForm }

procedure TVPForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.WndParent := Main.Handle;
end;

procedure TVPForm.FormCreate(Sender: TObject);
begin
    SetWindowLong(Handle, GWL_STYLE,
        GetWindowLong(Handle, GWL_STYLE) and not WS_CAPTION);
    Height       := 48;
    ClientHeight := Height;
    Refresh;
    SetTrackBarFace(VolBar);
    SetTrackBarFace(PosBar);

    Self.OnDeactivate := FormDeactivate;
        
    if not Main.staytop.Down then
      Main.TopMost(Self.Handle);
    if Main.VPps.x + ClientWidth > Screen.Width then
      Left := Main.VPps.x - ClientWidth
    else
      Left := Main.VPps.x;
    if Main.VPps.y + ClientHeight > Screen.Height then
      Top  := Main.VPps.y - ClientHeight
    else
      Top  := Main.VPps.y;

    VolBar.Position                  := Main.MP3Player1.Volume;
    Main.MP3Player1.OnChangePosition := VPChangePos;
    if Main.MP3Player1.IsOpen then
      try
        PosBar.OnChange := nil;
        try
          PosBar.Position := (100 * Main.MP3Player1.Position) div (Main.MP3Player1.Length + 1);
        except end;
      finally
        PosBar.OnChange := PosBarChange;
      end;
end;

procedure TVPForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
end;

procedure TVPForm.FormDeactivate(Sender: TObject);
begin
    Close;
end;

procedure TVPForm.VolBarChange(Sender: TObject);
begin
    Main.MP3Player1.Volume   := VolBar.Position;
    Main.ScrollBar1.Position := VolBar.Position;
end;

procedure TVPForm.VPChangePos(Sender: TObject);
begin
    with Main do
      if MP3Player1.IsOpen then begin
        try
          PosBar.OnChange := nil;
          try
            PosBar.Position := (100 * Main.MP3Player1.Position) div (Main.MP3Player1.Length + 1);
          except end;
        finally
          PosBar.OnChange := PosBarChange;
        end;
        case Main.cptType of
          cptMain:  MP3MainChangePosition(nil);
          cptSub:   MP3SubChangePosition(nil);
          cptScrll: MP3ScChangePosition(nil);
          cptEdit:  MP3EdChangePosition(nil);
        end;
      end;
end;

procedure TVPForm.PosBarChange(Sender: TObject);
begin
    with Main.MP3Player1 do
    if IsOpen then begin
    try
    Main.ScrollBar2.OnScroll := nil;
    Seek((Main.MP3Player1.Length * PosBar.Position) div 100);
    finally
    Main.ScrollBar2.OnScroll := Main.ScrollBar2Scroll; end;
    end;
end;

procedure TVPForm.FormDestroy(Sender: TObject);
begin
    Main.WVPCtrl := nil;
    Main.DecideChagePosEvent(true);
end;

procedure TVPForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) //and (chkEsc)
    then begin Key := Word(#0); Close; end;
end;

end.
